'\" Copyright 1991 Regents of the University of California
'\" Permission to use, copy, modify, and distribute this
'\" documentation for any purpose and without fee is hereby
'\" granted, provided that this notice appears in all copies.
'\" The University of California makes no representations about
'\" the suitability of this material for any purpose.  It is
'\" provided "as is" without express or implied warranty.
'\" 
'\" $Header: /local/src/cmds/sospexample/RCS/sospexample.man,v 1.1 91/11/17 17:56:27 jhh Exp Locker: jhh $ SPRITE (Berkeley)
'/" 
.so \*(]ltmac.sprite
.HS sospexample cmds
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
sospexample \- Sample post-processor for sosp file system traces that uses the sosp trace library.
.SH SYNOPSIS
\fBsospexample\fR [\fI-s -e -h -d -i -f\fR] \fItraceFile1 traceFile2 ...\fR
.SH OPTIONS
.IP "\fB\-s \fIstartTime\fR"
The timestamp in the traces at which to start processing.
.IP "\fB\-e \fIendTime\fR"
The timestamp in the traces at which to stop processing.
.IP "\fB\-h\fR" hoursToDo
How many hours of the trace to post-process.
.IP "\fB\-d \fIdirectory\fR
Directory containing the trace files.
.IP "\fB\-i \fIignoreFile\fR
File containing list of file IDs in the traces to be ignored (see below).
.IP "\fB\-f \fIfileList\fR
File containing list of the names of the trace files, since they can make too long a list for command-line arguements (see below).
.BE

.SH DESCRIPTION
.PP
This program is meant to be filled in by the user, where the comments suggest
doing so, in order to process the traces as the user desires.  The traces
themselves are organized in 5 directories, called traces1, traces2, traces3,
traces4 and traces5.  The first 3 trace directories each contain 2 sets of
24-hour traces, while traces4 and traces5 each contain only 1 set of 24-hour
traces.  In each of the directories, the traces are kept in subdirectories with
the name of the file server on which they were obtained.  There is also a
file called \fIfiles\fR that contains the names of the trace files to make
it easier to includes them as an argument to this post-processor.  Where
there are two sets of 24-hour traces, there are also files called \fIfiles.a\fR
and \fIfiles.b\fR, each containing the file names of one of the 24-hour sets.
Also, some of the directories contain a file called \fIignore\fR that gives
a list of file IDs to ignore in the trace events.  These are the file IDs of
the trace files themselves while the traces were running, and the tape
backup file IDs if the dumps were run at the time of the traces.

The header file, sosp.h, in the sosp library contains structure declarations
for the event traces and explains all their fields.

.SH KEYWORDS
sosp, traces, postprocessor
