/* 	@(#)a.out.h	4.2	(ULTRIX)	7/13/88					*/
/************************************************************************
 *									*
 *			Copyright (c) 1986,1988 by			*
 *		Digital Equipment Corporation, Maynard, MA		*
 *			All rights reserved.				*
 *									*
 *   This software is furnished under a license and may be used and	*
 *   copied  only  in accordance with the terms of such license and	*
 *   with the  inclusion  of  the  above  copyright  notice.   This	*
 *   software  or  any  other copies thereof may not be provided or	*
 *   otherwise made available to any other person.  No title to and	*
 *   ownership of the software is hereby transferred.			*
 *									*
 *   This software is  derived  from  software  received  from  the	*
 *   University    of   California,   Berkeley,   and   from   Bell	*
 *   Laboratories.  Use, duplication, or disclosure is  subject  to	*
 *   restrictions  under  license  agreements  with  University  of	*
 *   California and with AT&T.						*
 *									*
 *   The information in this software is subject to change  without	*
 *   notice  and should not be construed as a commitment by Digital	*
 *   Equipment Corporation.						*
 *									*
 *   Digital assumes no responsibility for the use  or  reliability	*
 *   of its software on equipment which is not supplied by Digital.	*
 *									*
 ************************************************************************/
/*
 *
 *   Modification History:
 *
 * 02 Apr 86 -- depp
 *	Moved struct exec and associated magic numbers to <sys/exec.h>
 *
 */
/*	a.out.h	4.1	83/05/03	*/

#ifndef _AOUT
#define _AOUT

#include <ds3100.md/nlist.h>
#include <ds3100.md/sys/exec.h>

/*
 * See syms.h for "mips" symbol table
 */


 /*		COMMON OBJECT FILE FORMAT

	File Organization:

	_______________________________________________    INCLUDE FILE
	|_______________HEADER_DATA___________________|
	|					      |
	|	File Header			      |    "filehdr.h"
	|.............................................|
	|					      |
	|	Auxilliary Header Information	      |	   "aouthdr.h"
	|					      |
	|_____________________________________________|
	|					      |
	|	".text" section header		      |	   "scnhdr.h"
	|					      |
	|.............................................|
	|					      |
	|	".data" section header		      |	      ''
	|					      |
	|.............................................|
	|					      |
	|	".bss" section header		      |	      ''
	|					      |
	|_____________________________________________|
	|______________RAW_DATA_______________________|
	|					      |
	|	".text" section data (rounded to 4    |
	|				bytes)	      |
	|.............................................|
	|					      |
	|	".data" section data (rounded to 4    |
	|				bytes)	      |
	|_____________________________________________|
	|____________RELOCATION_DATA__________________|
	|					      |
	|	".text" section relocation data	      |    "reloc.h"
	|					      |
	|.............................................|
	|					      |
	|	".data" section relocation data	      |       ''
	|					      |
	|_____________________________________________|
	|__________LINE_NUMBER_DATA_(SDB)_____________|
	|					      |
	|	".text" section line numbers	      |    "linenum.h"
	|					      |
	|.............................................|
	|					      |
	|	".data" section line numbers	      |	      ''
	|					      |
	|_____________________________________________|
	|________________SYMBOL_TABLE_________________|
	|					      |
	|	".text", ".data" and ".bss" section   |    "syms.h"
	|	symbols				      |	   "storclass.h"
	|					      |
	|_____________________________________________|
	|________________STRING_TABLE_________________|
	|					      |
	|	    long symbol names		      |
	|_____________________________________________|



		OBJECT FILE COMPONENTS

	HEADER FILES:
			/usr/include/filehdr.h
			/usr/include/aouthdr.h
			/usr/include/scnhdr.h
			/usr/include/reloc.h
			/usr/include/linenum.h
			/usr/include/syms.h
			/usr/include/storclass.h

	STANDARD FILE:
			/usr/include/a.out.h    "object file" 
   */

#include <ds3100.md/filehdr.h>
#include <ds3100.md/aouthdr.h>
#include <ds3100.md/scnhdr.h>
#include <ds3100.md/reloc.h>

/* Note if mips is defined syms.h includes sym.h and symconst.h */
#include <ds3100.md/syms.h>

/*
 * Coff files produced by the mips loader are guaranteed to have the raw data
 * for the sections follow the headers in this order: .text, .rdata, .data and
 * .sdata the sum of the sizes of last three is the value in dsize in the
 * optional header.  This is all done for the benefit of the programs that
 * have to load these objects so only the file header and optional header
 * have to be inspected.  The macro N_TXTOFF() takes pointers to file header
 * and optional header and returns the file offset to the start of the raw
 * data for the .text section.  The raw data for the three data sections
 * follows the start of the .text section by the value of tsize in the optional
 * header.
 *
 * Object files produced by pre 0.23 versions of the compiler had their sections
 * rounded to 8 byte boundaries.  0.23 and later versions have their sections
 * rounded to 16 (SCNROUND in scnhdr.h) byte boundaries.
 */
#if 0
 /* this is already defined in <sys/exec.h> */

#define N_TXTOFF(f, a) \
 ((a).magic == ZMAGIC || (a).magic == LIBMAGIC ? 0 : \
  ((a).vstamp < 23 ? \
   ((FILHSZ + AOUTHSZ + (f).f_nscns * SCNHSZ + 7) & 0xfffffff8) : \
   ((FILHSZ + AOUTHSZ + (f).f_nscns * SCNHSZ + SCNROUND-1) & ~(SCNROUND-1)) ) )
#endif

#endif /* _AOUT */
